wDDB = {["autoRepair"] = false, ["guildFunds"] = false, ["colorPerc"] = false, ["showCost"] = false, ["costNeutral"] = true, ["costFriendly"] = false, ["costHonored"] = false, ["costRevered"] = false, ["costExalted"] = false, ["lowestDur"] = false}
local defaults = {["autoRepair"] = false, ["guildFunds"] = false, ["colorPerc"] = false, ["showCost"] = false, ["costNeutral"] = true, ["costFriendly"] = false, ["costHonored"] = false, ["costRevered"] = false, ["costExalted"] = false, ["lowestDur"] = false}
local ldb = LibStub("LibDataBroker-1.1")
local wD = "|cffe1a500w|cff69ccf0Durability|cffffffff"
local noArmor = false
local head, shoul, chest, wrist, hand, belt, leg, feet, main, off, ranged -- Items
local headPerc, shoulPerc, chestPerc, wristPerc, handPerc, beltPerc, legPerc, feetPerc, mainPerc, offPerc, rangedPerc, avgPerc -- Durability Percents
local equippedRepair, invRepair = 0, 0
local wDurabilityScan = CreateFrame("GameTooltip")
local function moneyFormat(copper, earned)
	local moneyGold = floor(abs(copper / 10000))
	local moneySilver = floor(abs(mod(copper / 100, 100)))
	local moneyCopper = floor(abs(mod(copper, 100)))
	if (earned==1) then -- Gold (earned) tooltip
		if (copper<0) then
			return ("|cffff0000 - "..moneyGold.."|cffffcc00g |cffff0000"..moneySilver.."|cffc0c0c0s |cffff0000"..moneyCopper.."|cff996600c")
		elseif (copper>0) then
			return ("|cff00ff00 "..moneyGold.."|cffffcc00g |cff00ff00"..moneySilver.."|cffc0c0c0s |cff00ff00"..moneyCopper.."|cff996600c")
		elseif (copper==0) then
			return (moneyGold.."|cffffcc00g |cffffffff"..moneySilver.."|cffc0c0c0s |cffffffff"..moneyCopper.."|cff996600c")
		end
	else
		return ("|cffffffff"..moneyGold.."|cffffcc00g |cffffffff"..moneySilver.."|cffc0c0c0s |cffffffff"..moneyCopper.."|cff996600c")
	end
end
local function colorNum(num)
	if (wDDB.colorPerc==true) then
		if (num>=90) then
			num=("|cff00ff00"..num.."|r")
		elseif (num<90) and (num>80) then
			num=("|cffaaff00"..num.."|r")
		elseif (num<=80) and (num>70) then
			num=("|cffbbff00"..num.."|r")
		elseif (num<=70) and (num>60) then
			num=("|cffccee00"..num.."|r")
		elseif (num<=60) and (num>50) then
			num=("|cffdddd00"..num.."|r")
		elseif (num<=50) and (num>40) then
			num=("|cffeecc00"..num.."|r")
		elseif (num<=40) and (num>30) then
			num=("|cffffbb00"..num.."|r")
		elseif (num<=30) and (num>20) then
			num=("|cffff9900"..num.."|r")
		elseif (num<=20) and (num>10) then
			num=("|cffff3300"..num.."|r")
		elseif (num<=10) then
			num=("|cffff0000"..num.."|r")      
		end
	end
		return num
end
local function itemInfo(slot)
	local cost = 0
	local dur, max = GetInventoryItemDurability(slot)
	local perc, dif, equipped
	if (dur~=nil) then
		perc = math.ceil((dur/max)*100)
		dif = max - dur
		wDurabilityScan:ClearLines()
		cost = select(3, wDurabilityScan:SetInventoryItem("player", slot))
		equippedRepair = equippedRepair + cost
		equipped = true
	else
		perc = nil dif = nil
		equipped = false
	end
	return perc, equipped
end
local menuFrame = CreateFrame("Frame", "menuFrame", UIParent, "UIDropDownMenuTemplate", "MENU")

local Broker_wDurability = ldb:NewDataObject("Broker_wDurability", {
	type = "data source",
	text = "100%",
	value = 100,
	suffix = "%",
	icon = "interface\\minimap\\tracking\\repair",
	label = wD,
	OnClick = function(self, button)
		if button == "RightButton" then
			ToggleDropDownMenu(1, nil, menuFrame, self, 0, 15)
		end
	end,
	OnTooltipShow = function(tooltip)
		tooltip:AddLine(wD..":")
		tooltip:AddLine(" ")
		if (head==true) then
		tooltip:AddDoubleLine("Head", colorNum(headPerc).."%",1,1,1,1,1,1)
		end
		if (shoul==true) then
			tooltip:AddDoubleLine("Shoulder", colorNum(shoulPerc).."%",1,1,1,1,1,1)
		end
		if (chest==true) then
			tooltip:AddDoubleLine("Chest", colorNum(chestPerc).."%",1,1,1,1,1,1)
		end
		if (wrist==true) then
			tooltip:AddDoubleLine("Wrist", colorNum(wristPerc).."%",1,1,1,1,1,1)
		end
		if (hand==true) then
			tooltip:AddDoubleLine("Hand", colorNum(handPerc).."%",1,1,1,1,1,1)
		end
		if (belt==true) then
			tooltip:AddDoubleLine("Belt", colorNum(beltPerc).."%",1,1,1,1,1,1)
		end
		if (leg==true) then
			tooltip:AddDoubleLine("Leg", colorNum(legPerc).."%",1,1,1,1,1,1)
		end
		if (feet==true) then
			tooltip:AddDoubleLine("Feet", colorNum(feetPerc).."%",1,1,1,1,1,1)
		end
		if (main==true) then
			tooltip:AddDoubleLine("Main Hand", colorNum(mainPerc).."%",1,1,1,1,1,1)
		end
		if (off==true) then
			tooltip:AddDoubleLine("Off Hand", colorNum(offPerc).."%",1,1,1,1,1,1)
		end
		if (ranged==true) then
			tooltip:AddDoubleLine("Ranged", colorNum(rangedPerc).."%",1,1,1,1,1,1)
		end
		if (noArmor==true) then
			tooltip:AddLine("You have no armor on!")
		end
		if (wDDB.showCost==true) then
			tooltip:AddLine("________________________")
			tooltip:AddLine(" ")
			tooltip:AddLine("Repair Costs:")
			if (wDDB.costNeutral==true) then tooltip:AddDoubleLine("Neutral:", moneyFormat(equippedRepair + invRepair),1,1,1,1,1,1) end
			if (wDDB.costFriendly==true) then tooltip:AddDoubleLine("Friendly:", moneyFormat((equippedRepair + invRepair)*.95),1,1,1,1,1,1) end
			if (wDDB.costHonored==true) then tooltip:AddDoubleLine("Honored:", moneyFormat((equippedRepair + invRepair)*.9),1,1,1,1,1,1) end
			if (wDDB.costRevered==true) then tooltip:AddDoubleLine("Revered:", moneyFormat((equippedRepair + invRepair)*.85),1,1,1,1,1,1) end
			if (wDDB.costExalted==true) then tooltip:AddDoubleLine("Exalted:", moneyFormat((equippedRepair + invRepair)*.8),1,1,1,1,1,1) end
		end
		tooltip:AddLine(" ")
		tooltip:AddLine("|cff69ccf0Right-Click|cffffd200 for options")
	end,
})
local function armorUpdate()
	equippedRepair = 0
	invRepair = 0
	lowest = 100
	local totItems = 11
	headPerc, head = itemInfo(1) -- Head
	if (headPerc==nil) then 
		headPerc = 0
		totItems = totItems - 1
	else
		if (headPerc<lowest) then lowest = headPerc end
	end
	shoulPerc, shoul = itemInfo(3) -- Shoulder
	if (shoulPerc==nil) then
		shoulPerc = 0
		totItems = totItems - 1	
	else
		if (shoulPerc<lowest) then lowest = shoulPerc end
	end
	chestPerc, chest = itemInfo(5) -- Chest
	if (chestPerc==nil) then
		chestPerc = 0
		totItems = totItems - 1
	else
		if (chestPerc<lowest) then lowest = chestPerc end
	end
	wristPerc, wrist = itemInfo(9) -- Wrist
	if (wristPerc==nil) then	
		wristPerc = 0
		totItems = totItems - 1
	else
		if (wristPerc<lowest) then lowest = wristPerc end
	end
	handPerc, hand = itemInfo(10) -- Hand
	if (handPerc==nil) then
		handPerc = 0
		totItems = totItems - 1
	else
		if (handPerc<lowest) then lowest = handPerc end
	end
	beltPerc, belt = itemInfo(6) -- Waist
	if (beltPerc==nil) then
		beltPerc = 0
		totItems = totItems - 1
	else
		if (beltPerc<lowest) then lowest = beltPerc end
	end
	legPerc, leg = itemInfo(7) -- Legs
	if (legPerc==nil) then
		legPerc = 0
		totItems = totItems - 1
	else
		if (legPerc<lowest) then lowest = legPerc end
	end
	feetPerc, feet = itemInfo(8) -- Feet
	if (feetPerc==nil) then
		feetPerc = 0
		totItems = totItems - 1
	else
		if (feetPerc<lowest) then lowest = feetPerc  end
	end
	mainPerc, main = itemInfo(16) -- Main Hand	
	if (mainPerc==nil) then
		mainPerc = 0
		totItems = totItems - 1
	else
		if (mainPerc<lowest) then lowest = mainPerc end
	end
	offPerc, off = itemInfo(17) -- Off Hand
	if (offPerc==nil) then
		offPerc = 0
		totItems = totItems - 1
	else
		if (offPerc<lowest) then lowest = offPerc end
	end
	rangedPerc, ranged = itemInfo(18) -- Ranged
	if (rangedPerc==nil) then
		rangedPerc = 0
		totItems = totItems - 1
	else
		if (rangedPerc<lowest) then lowest = rangedPerc end
	end
	if (totItems==0) then
		Broker_wDurability.text = ("No armor")
		noArmor = true
	else
		avgPerc = (headPerc + shoulPerc + chestPerc + wristPerc + handPerc + beltPerc + legPerc + feetPerc + mainPerc + offPerc + rangedPerc)/totItems
		avgPerc = math.floor(avgPerc)
		if (wDDB.lowestDur==true) then Broker_wDurability.text = (colorNum(lowest).."%") Broker_wDurability.value = (colorNum(lowest)) else Broker_wDurability.text = (colorNum(avgPerc).."%") Broker_wDurability.value = (colorNum(avgPerc)) end
		noArmor = false
	end
	for bagNum = 0,4 do
	local cost = 0
		for slotNum = 1,GetContainerNumSlots(bagNum) do
			local item = GetContainerItemLink(bagNum, slotNum)
			if (item) then
				local dur, max = GetContainerItemDurability(bagNum, slotNum)
				if (dur~=nil) then
					local dif = max - dur
					wDurabilityScan:ClearLines()
					cost = select(2, wDurabilityScan:SetBagItem(bagNum, slotNum))
					invRepair = invRepair + cost
				end
			end
		end
	end
end

local options = {
	level1 = {
		{text = "Auto repair gear", value = "autoRepair", isNotRadio = true, keepShownOnClick = true, func = (function() if (wDDB.autoRepair==false) then wDDB.autoRepair = true else wDDB.autoRepair = false end end)},
		{text = "Show repair cost", value = "showCost", isNotRadio = true, keepShownOnClick = true, func = (function() if (wDDB.showCost==false) then wDDB.showCost = true else wDDB.showCost = false end end)},
		{text = "Repair discount", value = "costDiscount", isNotRadio = true, keepShownOnClick = true, notCheck = true, hasArrow = true},
		{text = "Use guild funds", value = "guildFunds", isNotRadio = true, keepShownOnClick = true, func = (function() if (wDDB.guildFunds==false) then wDDB.guildFunds = true else wDDB.guildFunds = false end end)},
		{text = "Color by percent", value = "colorPerc", isNotRadio = true, keepShownOnClick = true, func = (function() if (wDDB.colorPerc==false) then wDDB.colorPerc = true else wDDB.colorPerc = false end armorUpdate() end)},
		{text = "Display", value = "display", isNotRadio = true, keepShownOnClick = true, notCheck = true, hasArrow = true},
		{text = nil, value = nil, disabled = true, notCheck = true},
		{text = "Close", value = nil, keepShowOnClick = false, notCheck = true}
	},
	level2 = {
		costDiscount = {
			{text = "Neutral", value = "costNeutral", func = (function() if (wDDB.costNeutral==false) then wDDB.costNeutral = true else wDDB.costNeutral = false end end)},
			{text = "Friendly", value = "costFriendly", func = (function() if (wDDB.costFriendly==false) then wDDB.costFriendly = true else wDDB.costFriendly = false end end)},
			{text = "Honored", value = "costHonored", func = (function() if (wDDB.costHonored==false) then wDDB.costHonored = true else wDDB.costHonored = false end end)},
			{text = "Revered", value = "costRevered", func = (function() if (wDDB.costRevered==false) then wDDB.costRevered = true else wDDB.costRevered = false end end)},
			{text = "Exalted", value = "costExalted", func = (function() if (wDDB.costExalted==false) then wDDB.costExalted = true else wDDB.costExalted = false end end)}
		},
		display = {
			{text = "Average durability", value = "avgDur", func = (function() wDDB.lowestDur = false UIDropDownMenu_SetSelectedValue(menuFrame, "avgDur") armorUpdate() end)},
			{text = "Lowest durability", value = "lowDur", func = (function() wDDB.lowestDur = true UIDropDownMenu_SetSelectedValue(menuFrame, "lowDur") armorUpdate() end)}
		}
	}
}
local function initialize(self, level)
	local val = UIDROPDOWNMENU_MENU_VALUE
	if (level==1) then
		local title = UIDropDownMenu_CreateInfo()
		title = UIDropDownMenu_CreateInfo()
		title.text = wD
		title.isTitle = true
		title.notCheckable = true
		UIDropDownMenu_AddButton(title, level)
		local info = UIDropDownMenu_CreateInfo()
		for k,v in pairs(options.level1) do
			info = UIDropDownMenu_CreateInfo()
			if (v.disabled~=nil) then info.disabled = v.disabled end
			if (v.notCheck~=nil) then info.notCheckable = v.notCheck end
			if (v.hasArrow~=nil) then info.hasArrow = v.hasArrow end
			info.text = v.text
			info.value = v.value
			info.isNotRadio = v.isNotRadio
			info.checked = wDDB[v.value]
			info.keepShownOnClick = v.keepShownOnClick
			if (v.func~=nil) then info.func = v.func end
			UIDropDownMenu_AddButton(info, level)
	   end
	elseif (level==2) then
		if (val=="costDiscount") then
			local info = UIDropDownMenu_CreateInfo()
			for k,v in pairs(options.level2.costDiscount) do
				info = UIDropDownMenu_CreateInfo()
				info.text = v.text
				info.value = v.value
				info.isNotRadio = true
				info.keepShownOnClick = true
				info.checked = wDDB[v.value]
				info.func = v.func
				UIDropDownMenu_AddButton(info, level)
			end
		elseif (val=="display") then
			local info = UIDropDownMenu_CreateInfo()
			for k,v in pairs(options.level2.display) do
				info = UIDropDownMenu_CreateInfo()
				info.text = v.text
				info.value = v.value
				info.keepShownOnClick = true
				info.func = v.func
				UIDropDownMenu_AddButton(info, level)
			end
			if (wDDB.lowestDur==true) then UIDropDownMenu_SetSelectedValue(menuFrame, "lowDur") else UIDropDownMenu_SetSelectedValue(menuFrame, "avgDur") end
		end
	end
end
UIDropDownMenu_Initialize(menuFrame, initialize, "MENU")
UIDropDownMenu_SetWidth(menuFrame, 100);
UIDropDownMenu_SetButtonWidth(menuFrame, 124)
UIDropDownMenu_JustifyText(menuFrame, "LEFT")


local OnEvent = CreateFrame("Frame")
OnEvent:RegisterEvent("PLAYER_ENTERING_WORLD")
OnEvent:SetScript("OnEvent", function(self, event, arg1, arg2, arg3)
	if (event=="ADDON_LOADED") then
		if (arg1=="Broker_wDurability") then
			for k,v in pairs(defaults) do
				if (wDDB[k]==nil) then wDDB[k] = defaults[v] end
			end
		end
	elseif (event=="PLAYER_ENTERING_WORLD") or (event=="UPDATE_INVENTORY_DURABILITY") then
		armorUpdate()
	elseif (event=="MERCHANT_SHOW") then
		local cost, canRepair = GetRepairAllCost()
		if (canRepair==1) then
			if (wDDB.autoRepair==true) then
				if (wDDB.guildFunds==true) then
					if (CanGuildBankRepair()==1) then
						RepairAllItems(1)
						print(wD..": repaired all items for: "..moneyFormat(cost).."|cffffffff with guild funds")
					else
						RepairAllItems()
						print(wD..": repaired all items for: "..moneyFormat(cost).."|cffffffff (Guild funds unavailable)")
					end
				else
					if (cost<=GetMoney()) then
						RepairAllItems()
						print(wD..": repaired all items for: "..moneyFormat(cost))
					elseif (cost>GetMoney()) then
						print(wD..": You don't have enough money to repair your armor!")
					end
				end
			end
		end
	end
end)
OnEvent:RegisterEvent("ADDON_LOADED")
OnEvent:RegisterEvent("UPDATE_INVENTORY_DURABILITY")
OnEvent:RegisterEvent("MERCHANT_SHOW")