-- Druid: 11

--[[DRUID:
Restoration	105
Guardian	104
Feral		103
Balance		102
]]--

if (select(3, UnitClass("player")) ~= 11) then return end 

-- What you get.
local gains = {
	[1] = {[102] = 122292, [104] = 113002, [103] = 112997, [105] = 113004,}, --Warrior
	[2] = {[102] = 110698, [104] = 110701, [103] = 110700, [105] = 122288,}, --Paladin
	[3] = {[102] = 110588, [104] = 110600, [103] = 110597, [105] = 110617,}, --Hunter
	[4] = {[102] = 110788, [104] = 122289, [103] = 110730, [105] = 110791,}, --Rogue
	[5] = {[102] = 110707, [104] = 110717, [103] = 110715, [105] = 110718,}, --Priest
	[6] = {[102] = 110570, [104] = 122285, [103] = 122282, [105] = 110575,}, --DK
	[7] = {[102] = 110802, [104] = 110803, [103] = 110807, [105] = 110806,}, --Shaman
	[8] = {[102] = 110621, [104] = 110694, [103] = 110693, [105] = 110696,}, --Mage
	[9] = {[102] = 122291, [104] = 122290, [103] = 110810, [105] = 112970,}, --Warlock
	[10] = {[102] = 126458, [104] = 126453, [103] = 126449, [105] = 126456,}, --Monk
}

-- What you give.
local gives = {
	[62] = 113074, -- Arcane Mage
	[63] = 113074, -- Fire Mage
	[64] = 113074, -- Frost Mage
	[65] = 113269, -- Holy Paladin
	[66] = 122287, -- Prot Paladin
	[70] = 122287, -- Ret Paladin
	[71] = 122294, -- Arms Warrior
	[72] = 122294, -- Fury Warrior
	[73] = 122294, -- Prot Warrior
	[250] = 113516, -- Blood DK
	[251] = 113516, -- Frost DK
	[252] = 113516, -- Unholy DK
	[253] = 113073, -- BM Hunter
	[254] = 113073, -- Marks Hunter
	[255] = 113073, -- Surv Hunter
	[256] = 113506, -- Disc Priest
	[257] = 113506, -- Holy Priest
	[258] = 113277, -- Shadow Priest
	[259] = 113613, -- Assa Rogue
	[260] = 113613, -- Combat Rogue
	[261] = 113613, -- Sub Rogue
	[262] = 113286, -- Ele Shaman
	[263] = 113286, -- Enh Shaman
	[264] = 113289, -- Resto Shaman
	[265] = 113295, -- Afflic Lock
	[266] = 113295, -- Demo Lock
	[267] = 113295, -- Dest Lock
	[268] = 127361, -- BM Monk
	[269] = 127361, -- WW Monk
	[270] = 113275, -- MW Monk
}

-- Start the magic
SymbioTeller = CreateFrame("frame")
local ScanTip = CreateFrame("GameTooltip", "ScanTip", nil, "GameTooltipTemplate")
ScanTip:SetOwner(WorldFrame, "ANCHOR_NONE");
local st = SymbioTeller
local pdesc, tdesc = ""

-- Sets the defaults
local defaults = {
	player = {
		desc = true,
		shift = false,
	},
	target = {
		desc = true,
		shift = false,
	},
	incombat = false,
}
SymbioTellerDB = defaults

function st:ts()
	if (SymbioTellerDB.incombat) and (InCombatLockdown() == 1) then return else
		if (select(3, UnitClass("mouseover")) ~= 11) and (GetSpecialization() ~= nil) then --target ain't druid and you have a spec.
			if (UnitIsFriend("player", "mouseover")) and (UnitIsPlayer("mouseover")) then
				local class = select(3, UnitClass("mouseover"))
				local spec = GetSpecialization()
				spec = GetSpecializationInfo(spec)
				local name, _, icon = GetSpellInfo(gains[class][spec])
				if (not SymbioTellerDB.player.shift) or (SymbioTellerDB.player.shift and IsShiftKeyDown()) then
					if (SymbioTellerDB.player.desc) then
						ScanTip:SetSpellByID(gains[class][spec])
						pdesc = "|cFF00FF00" .. _G["ScanTipTextLeft" .. ScanTip:NumLines()]:GetText()
						pdesc = string.gsub(pdesc, "|R", "")
					end
					GameTooltip:AddLine("\nSymbioTeller")
					GameTooltip:AddDoubleLine("|T" .. icon .. ":22|t " .. name, "Gains", 1, 1, 1)
					GameTooltip:AddLine(pdesc, 1, 1, 1, true)
				end
				
				if (not SymbioTellerDB.target.shift) or (SymbioTellerDB.target.shift and IsShiftKeyDown()) then
					GameTooltip:AddLine(" ")
					if (CheckInteractDistance("mouseover", 1)) and (CanInspect("mouseover")) then 
						st:RegisterEvent("INSPECT_READY")
						NotifyInspect("mouseover")
					else
						GameTooltip:AddLine("Not in range")
					end
				end
			end
		end
	end
end

st:RegisterEvent("INSPECT_READY")
st:SetScript("OnEvent", function(self, event, ...)
	local args = {...}
	if (event == "INSPECT_READY") then
		if (UnitGUID("mouseover") == args[1]) then
			local spec = GetInspectSpecialization("mouseover") or nil
			if (spec == nil) or (spec <= 0) then return end -- Prevents error if player doesn't have a spec.
			local name, _, icon = GetSpellInfo(gives[spec])
			ScanTip:SetSpellByID(gives[spec])
			if (SymbioTellerDB.target.desc) then
				ScanTip:SetSpellByID(gives[spec])
				tdesc = "|cFF00FF00" .. _G["ScanTipTextLeft" .. ScanTip:NumLines()]:GetText()
				tdesc = string.gsub(tdesc, "|R", "")
			end
			GameTooltip:AddDoubleLine("|T" .. icon .. ":22|t " .. name, "Gives", 1, 1, 1)
			GameTooltip:AddLine(tdesc, 1, 1, 1, true)
			GameTooltip:Show()
			st:UnregisterEvent("INSPECT_READY")
		end
	end
end)
	
GameTooltip:HookScript("OnTooltipSetUnit", function(self, ...)
	st:ts()
end)

-- Slash commands
SLASH_SYMBIOTELLER1 = "/symb"
local function handler(msg, editBox)
    if (msg == "pdesc") then
		SymbioTellerDB.player.desc = not SymbioTellerDB.player.desc
		if (SymbioTellerDB.player.desc) then
			DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFFSymbioTeller:|cFF00FF00 ON:|r Spell gained description.")
		else
			pdesc = ""
			DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFFSymbioTeller:|cFFFF0000 OFF:|r Spell gained description.")
		end
	elseif (msg == "pshift") then
		SymbioTellerDB.player.shift = not SymbioTellerDB.player.shift
		if (SymbioTellerDB.player.shift) then
			DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFFSymbioTeller:|cFF00FF00 ON:|r Displays spell gained when shift is pressed.")
		else
			DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFFSymbioTeller:|cFFFF0000 OFF:|r Displays spell gained when shift is pressed.")
		end
	elseif (msg == "tdesc") then
		SymbioTellerDB.target.desc = not SymbioTellerDB.target.desc
		if (SymbioTellerDB.target.desc) then
			DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFFSymbioTeller:|cFF00FF00 ON:|r Spell granted description.")
		else
			tdesc = ""
			DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFFSymbioTeller:|cFFFF0000 OFF:|r Spell granted description.")
		end
	elseif (msg == "tshift") then
		SymbioTellerDB.target.shift = not SymbioTellerDB.target.shift
		if (SymbioTellerDB.target.shift) then
			DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFFSymbioTeller:|cFF00FF00 ON:|r Displays spell granted when shift is pressed.")
		else
			DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFFSymbioTeller:|cFFFF0000 OFF:|r Displays spell granted when shift is pressed.")
		end
	elseif (msg == "incombat") then
		SymbioTellerDB.incombat = not SymbioTellerDB.incombat
		if (SymbioTellerDB.incombat) then
			DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFFSymbioTeller:|cFF00FF00 ON:|r SymbioTeller will not work while in combat.")
		else
			DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFFSymbioTeller:|cFFFF0000 OFF:|r SymbioTeller will not work while in combat.")
		end
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFFSymbioTeller:|r Commands:")
		DEFAULT_CHAT_FRAME:AddMessage("   |cFFFFFF00/pdesc|r - Toggles the spell gained description.")
		DEFAULT_CHAT_FRAME:AddMessage("   |cFFFFFF00/pdesc|r - Toggles the spell granted description.")
		DEFAULT_CHAT_FRAME:AddMessage("   |cFFFFFF00/pshift|r - Toggles if spell gained will be shown when shift key is pressed.")
		DEFAULT_CHAT_FRAME:AddMessage("   |cFFFFFF00/tshift|r - Toggles if spell granted will be shown when shift key is pressed.")
		DEFAULT_CHAT_FRAME:AddMessage("   |cFFFFFF00/incombat|r - Toggles if SymbioTeller will work while in combat.")
	end
end
SlashCmdList["SYMBIOTELLER"] = handler