﻿local NAME, addon = ...

local locales = {
	enUS = {
		config_groups = {
			interaction = "Interaction",
			appearance = "Appearance",
			size = "Size and Transparency",
			general = "General",
		},
		config_panels = {
			options = "Options"
		},
		config = {
			autoloot_coin = "Auto loot coin",
			autoloot_quest = "Auto loot quest items",
			when_never = "Never",
			when_solo = "Solo",
			when_always = "Always",
			when_auto = "Automatic",
			frame_scale = "Frame scale",
			frame_scale_low = "Small",
			frame_scale_high = "Large",
			frame_alpha = "Frame transparency",
			frame_alpha_low = "Transparent",
			frame_alpha_high = "Opaque",
			frame_color_border = "Frame border color",
			frame_color_backdrop = "Frame backdrop color",
			frame_color_gradient = "Frame gradient color",
			frame_width_automatic = "Automatically expand frame",
			frame_width = "Frame width",
			loot_highlight = "Highlight slots on mouseover",
			loot_alpha = "Slot transparency",
			loot_alpha_low = "Transparent",
			loot_alpha_high = "Opaque",
			loot_color_border = "Loot border color",
			loot_color_backdrop = "Loot backdrop color",
			loot_color_gradient = "Loot gradient color",
			loot_color_info = "Information font color",
			loot_collapse = "Collapse looted slots",
			quality_color_frame = "Color frame border by top quality",
			quality_color_loot = "Color loot border by quality",
			loot_texts_info = "Show detailed information",
			loot_texts_bind = "Show loot bind type",
			font_size_loot = "Loot font size",
			font_size_info = "Information font size",
			frame_snap = "Snap frame to mouse",
			frame_snap_offset_x = "Horizontal snap offset",
			frame_snap_offset_y = "Vertical snap offset",
			frame_draggable = "Loot frame draggable",
			linkall_threshold = "Minimum chat link quality",
			linkall_channel = "Default chat link channel",
			linkall_show = "Link button visibility",
			skin = "Skin",
			skin_default = "XLoot: Default",
			skin_legacy = "XLoot: Legacy",
			skin_smooth = "XLoot: Smooth",
		},
		linkall_threshold_missed = "No loot meets your quality threshold",
		button_link = "Link",
		button_close = "Close",
		bind_on_use_short = "BoU",
		bind_on_equip_short = "BoE",
		bind_on_pickup_short = "BoP"
	},
	-- Possibly localized
	ptBR = {},
	frFR = {},
	deDE = {},
	koKR = {},
	esMX = {},
	ruRU = {},
	zhCN = {},
	esES = {},
	zhTW = {},
}

-- Automatically inserted translations
-- See: http://wow.curseforge.com/addons/xloot-1-0/localization/ to create or fix translations
locales.ptBR.config = {
}
locales.ptBR.config_groups = {
}
locales.ptBR.config_panels = {
}

locales.frFR["bind_on_equip_short"] = "LqE" -- Needs review
locales.frFR["bind_on_pickup_short"] = "LqR" -- Needs review
locales.frFR["bind_on_use_short"] = "LqU" -- Needs review
locales.frFR["button_close"] = "Fermer" -- Needs review
locales.frFR["button_link"] = "Lien" -- Needs review
locales.frFR["linkall_threshold_missed"] = "Aucun butin ne rencontre votre seuil de qualité" -- Needs review
locales.frFR.config = {
	font_size_info = "Taille de police des informations", -- Needs review
	font_size_loot = "Taille de police du nom du butin", -- Needs review
	frame_alpha = "Transparence du cadre", -- Needs review
	frame_alpha_high = "Opaque", -- Needs review
	frame_alpha_low = "Transparent", -- Needs review
	frame_color_backdrop = "Couleur de fond du cadre", -- Needs review
	frame_color_border = "Couleur de bordure du cadre", -- Needs review
	frame_color_gradient = "Couleur de gradient du cadre", -- Needs review
	frame_draggable = "Cadre du butin saisissable", -- Needs review
	frame_scale = "Échelle du cadre", -- Needs review
	frame_scale_high = "Large", -- Needs review
	frame_scale_low = "Petite", -- Needs review
	frame_width = "Largeur de cadre", -- Needs review
	frame_width_automatic = "Étendre auto. le cadre", -- Needs review
	linkall_channel = "Canal de discussion par défaut pour les liens", -- Needs review
	linkall_threshold = "Qualité minimale des liens dans la discussion", -- Needs review
	loot_alpha = "Transparence d'emplacement", -- Needs review
	loot_alpha_high = "Opaque", -- Needs review
	loot_alpha_low = "Transparent", -- Needs review
	loot_collapse = "Réduire les emplacements ramassés", -- Needs review
	loot_color_backdrop = "Couleur de fond du butin", -- Needs review
	loot_color_border = "Couleur de bordure du butin", -- Needs review
	loot_color_gradient = "Gradient de couleur du butin", -- Needs review
	loot_color_info = "Couleur de police des informations", -- Needs review
	loot_highlight = "Emplacements en surbrillance au survol", -- Needs review
	loot_texts_bind = "Afficher le type de lien du butin", -- Needs review
	loot_texts_info = "Afficher des informations détaillées", -- Needs review
	quality_color_frame = "Colorer bordures du cadre selon la qualité", -- Needs review
	quality_color_loot = "Colorer bordures du butin selon la qualité", -- Needs review
	skin = "Skin", -- Needs review
	skin_default = "XLoot : défaut", -- Needs review
	skin_legacy = "XLoot : héritage", -- Needs review
}
locales.frFR.config_groups = {
	appearance = "Apparence", -- Needs review
	general = "Général", -- Needs review
	interaction = "Interaction", -- Needs review
	size = "Taille et Transparence", -- Needs review
}
locales.frFR.config_panels = {
	options = "Options", -- Needs review
}

locales.deDE["bind_on_equip_short"] = "BoE" -- Needs review
locales.deDE["bind_on_pickup_short"] = "BoP" -- Needs review
locales.deDE["bind_on_use_short"] = "BoU" -- Needs review
locales.deDE["button_close"] = "Schliessen"
locales.deDE["button_link"] = "Link" -- Needs review
locales.deDE.config = {
	frame_scale_high = "Groß",
	frame_scale_low = "Klein",
	loot_alpha_low = "Transparent", -- Needs review
	skin = "Skin", -- Needs review
	skin_default = "XLoot: Standard", -- Needs review
	skin_legacy = "XLoot: Legacy", -- Needs review
}
locales.deDE.config_groups = {
	appearance = "Aussehen",
	general = "Allgemein", -- Needs review
}
locales.deDE.config_panels = {
	options = "Optionen", -- Needs review
}

locales.koKR.config = {
	font_size_info = "정보 글자 크기", -- Needs review
	font_size_loot = "룻 글자 크기", -- Needs review
	frame_alpha = "프레임 투명도", -- Needs review
	frame_alpha_high = "불투명하게", -- Needs review
	frame_alpha_low = "투명하게", -- Needs review
	frame_color_backdrop = "프레임 배경 색상", -- Needs review
	frame_color_border = "프레임 외각 색상", -- Needs review
	frame_color_gradient = "프레임 그라데이션 색상", -- Needs review
	frame_draggable = "루팅 프레임 이동가능", -- Needs review
	frame_scale = "프레임 크기", -- Needs review
	frame_scale_high = "크게", -- Needs review
	frame_scale_low = "작게", -- Needs review
	frame_snap = "마우스로 이동", -- Needs review
	frame_snap_offset_x = "수평 고정 좌표", -- Needs review
	frame_snap_offset_y = "수직 고정 좌표", -- Needs review
	frame_width = "프레임 폭", -- Needs review
	frame_width_automatic = "프레임 자동 확장", -- Needs review
	linkall_channel = "기본 알림 채널", -- Needs review
	linkall_threshold = "알릴 최소품질", -- Needs review
	loot_alpha = "슬롯 투명도", -- Needs review
	loot_alpha_high = "불투명하게", -- Needs review
	loot_alpha_low = "투명하게", -- Needs review
}
locales.koKR.config_groups = {
	appearance = "색상", -- Needs review
	interaction = "상호작용", -- Needs review
}
locales.koKR.config_panels = {
}

locales.esMX.config = {
}
locales.esMX.config_groups = {
}
locales.esMX.config_panels = {
}

locales.ruRU["bind_on_equip_short"] = "ПпН"
locales.ruRU["bind_on_pickup_short"] = "ПпП"
locales.ruRU["bind_on_use_short"] = "ПпИ"
locales.ruRU["button_close"] = "Закрыть"
locales.ruRU["button_link"] = "Ссылка"
locales.ruRU["linkall_threshold_missed"] = "Нет добычи соответствующей требованиям качества"
locales.ruRU.config = {
	font_size_info = "Размер шрифта для информации",
	font_size_loot = "Размер шрифта для добычи",
	frame_alpha = "Прозрачность окошка",
	frame_alpha_high = "Непрозрачный",
	frame_alpha_low = "Прозрачный",
	frame_color_backdrop = "Цвет фона окошка",
	frame_color_border = "Цвет рамки окошка",
	frame_color_gradient = "Цвет градиента окошка",
	frame_draggable = "Окошко добычи передвигаемо",
	frame_scale = "Размер окошка",
	frame_scale_high = "Большой",
	frame_scale_low = "Маленький",
	frame_snap = "Привязать окошко к мыши",
	frame_snap_offset_x = "Смещение по горизонтали",
	frame_snap_offset_y = "Смещение по вертикали",
	frame_width = "Ширина окошка",
	frame_width_automatic = "Автоматически расширять окошко",
	linkall_channel = "Чат для отображения по умолчанию",
	linkall_threshold = "Минимальная ссылка в чате",
	loot_alpha = "Прозрачность ячейки",
	loot_alpha_high = "Непрозрачная",
	loot_alpha_low = "Прозрачная",
	loot_collapse = "Свернуть собранные ячейки",
	loot_color_backdrop = "Фоновый цвет для добычи",
	loot_color_border = "Цвет для рамки добычи",
	loot_color_gradient = "Цвет градиента добычи",
	loot_color_info = "Цвет шрифта информации",
	loot_highlight = "Подсвечивать ячейки при наведении мыши",
	loot_texts_bind = "Показывать добычу по типу",
	loot_texts_info = "Показывать подробную информацию",
	quality_color_frame = "Окрашивать рамку окошка по наивысшему качеству",
	quality_color_loot = "Окрашивать рамку добычи по качеству",
	skin = "Шкурка",
	skin_default = "XLoot: Стандарт",
	skin_legacy = "XLoot: Наследие",
}
locales.ruRU.config_groups = {
	appearance = "Внешний вид",
	general = "Главные",
	interaction = "Взаимодействие",
	size = "Размеры и прозрачность",
}
locales.ruRU.config_panels = {
	options = "Настройки",
}

locales.zhCN["bind_on_equip_short"] = "装绑"
locales.zhCN["bind_on_pickup_short"] = "拾绑"
locales.zhCN["bind_on_use_short"] = "用绑"
locales.zhCN["button_close"] = "关闭"
locales.zhCN["button_link"] = "链接"
locales.zhCN["linkall_threshold_missed"] = "所有物品都低于最低品质限制"
locales.zhCN.config = {
	font_size_info = "物品信息字体大小",
	font_size_loot = "物品名称字体大小",
	frame_alpha = "拾取框透明度",
	frame_alpha_high = "不透明",
	frame_alpha_low = "透明",
	frame_color_backdrop = "拾取框背景颜色",
	frame_color_border = "拾取框边框颜色",
	frame_color_gradient = "拾取框渐变颜色",
	frame_draggable = "可拖动更改拾取框位置",
	frame_scale = "拾取框缩放",
	frame_scale_high = "大",
	frame_scale_low = "小",
	frame_snap = "鼠标位置打开拾取框",
	frame_snap_offset_x = "水平偏移",
	frame_snap_offset_y = "垂直偏移",
	frame_width = "拾取框宽度",
	frame_width_automatic = "自动调整拾取框宽度",
	linkall_channel = "默认发送物品链接到频道",
	linkall_threshold = "发送链接的物品品质最低为",
	loot_alpha = "物品单元格透明度",
	loot_alpha_high = "不透明",
	loot_alpha_low = "透明",
	loot_collapse = "重复物品合并显示",
	loot_color_backdrop = "物品单元格背景颜色",
	loot_color_border = "物品单元格边框颜色",
	loot_color_gradient = "物品单元格渐变颜色",
	loot_color_info = "物品信息字体颜色",
	loot_highlight = "高亮鼠标指向的物品",
	loot_texts_bind = "显示物品绑定类型",
	loot_texts_info = "显示物品详细信息(部位/类型等)",
	quality_color_frame = "根据最高物品品质着色拾取框边框",
	quality_color_loot = "根据物品品质着色物品单元格边框",
	skin = "外观",
	skin_default = "XLoot: 默认",
	skin_legacy = "XLoot: 经典",
}
locales.zhCN.config_groups = {
	appearance = "外观",
	general = "常规",
	interaction = "互动",
	size = "大小与透明度",
}
locales.zhCN.config_panels = {
	options = "选项",
}

locales.esES.config = {
}
locales.esES.config_groups = {
}
locales.esES.config_panels = {
}

locales.zhTW["bind_on_equip_short"] = "裝備後綁定"
locales.zhTW["bind_on_pickup_short"] = "拾取後綁定"
locales.zhTW["bind_on_use_short"] = "使用後綁定"
locales.zhTW["button_close"] = "關閉"
locales.zhTW["button_link"] = "連結"
locales.zhTW["linkall_threshold_missed"] = "拾取沒有達到你的品質門檻"
locales.zhTW.config = {
	font_size_info = "訊息字型大小",
	font_size_loot = "拾取字型大小",
	frame_alpha = "框架透明度",
	frame_alpha_high = "不透明",
	frame_alpha_low = "透明",
	frame_color_backdrop = "框架背景顏色",
	frame_color_border = "框架邊框顏色",
	frame_color_gradient = "框架傾斜顏色",
	frame_draggable = "可移動拾取框架",
	frame_scale = "框架縮放",
	frame_scale_high = "大",
	frame_scale_low = "小",
	frame_snap = "依附至鼠標",
	frame_snap_offset_x = "依附水平偏移",
	frame_snap_offset_y = "依附垂直偏移",
	frame_width = "框架寬度",
	frame_width_automatic = "自動延伸框架",
	linkall_channel = "預設廣播頻道",
	linkall_threshold = "可連結到頻道的最低品質",
	loot_alpha = "格子透明度",
	loot_alpha_high = "不透明",
	loot_alpha_low = "透明",
	loot_collapse = "折疊拾取格子",
	loot_color_backdrop = "拾取框背景顏色",
	loot_color_border = "拾取框邊框顏色",
	loot_color_gradient = "拾取框傾斜顏色",
	loot_color_info = "細節訊息顏色",
	loot_highlight = "高亮在滑鼠懸停",
	loot_texts_bind = "顯示拾取綁定類型",
	loot_texts_info = "顯示細節訊息",
	quality_color_frame = "以最高品質上色框架",
	quality_color_loot = "以品質上色拾取框架",
	skin = "外觀",
	skin_default = "XLoot: 預設",
	skin_legacy = "XLoot: 傳統",
}
locales.zhTW.config_groups = {
	appearance = "外觀",
	general = "一般",
	interaction = "互動",
	size = "大小與透明度",
}
locales.zhTW.config_panels = {
	options = "選項",
}


local L = locales[GetLocale()] and locales[GetLocale()] or locales.enUS
if L ~= locales.enUS then
	setmetatable(L, { __index = locales.enUS })
	for k, v in pairs(L) do	
		if type(v) == 'table' then
			setmetatable(v, { __index = locales.enUS[k] })
		end
	end
end
addon.L = L
