local MicroMenu = LibStub('LibDataBroker-1.1'):NewDataObject('nioBroker_MicroMenu', { 
	type = 'data source',
	text = 'MicroMenu',
	icon = [[Interface\GROUPFRAME\UI-Group-LeaderIcon]],
	MenuEntries = {
		{
			text = MAINMENU_BUTTON,
			isTitle = true,
			notCheckable = true,
		},
		{
			text = CHARACTER_BUTTON,
			func = function() 
				securecall(ToggleCharacter, 'PaperDollFrame') 
			end,
			notCheckable = true,
		},
		{
			text = SPELLBOOK_ABILITIES_BUTTON,
			func = function() 
				securecall(ToggleSpellBook, BOOKTYPE_SPELL)
			end,
			notCheckable = true,
		},
		{
			text = TALENTS_BUTTON,
			func = function() 
				if not PlayerTalentFrame then 
					LoadAddOn('Blizzard_TalentUI') 
				end
				if not GlyphFrame then 
					LoadAddOn('Blizzard_GlyphUI') 
				end 
				PlayerTalentFrame_Toggle()
			end,
			notCheckable = true,
		},
		{
			text = PET_JOURNAL,
			func = function() 
				securecall(TogglePetJournal) 
			end,
			notCheckable = true,
		},
		{
			text = BACKPACK_TOOLTIP,
			func = function() 
				securecall(ToggleAllBags) 
			end,
			notCheckable = true,
		},
		{
			text = " ",
			notCheckable = true,
		},
		{
			text = ACHIEVEMENT_BUTTON,
			func = function() 
				securecall(ToggleAchievementFrame) 
			end,
			notCheckable = true,
		},
		{
			text = QUESTLOG_BUTTON,
			func = function() 
				securecall(ToggleFrame, QuestLogFrame) 
			end,
			notCheckable = true,
		},
		{
			text = RAID,
			func = function() 
				securecall(ToggleFriendsFrame, 4)
			end,
			notCheckable = true,
		},
		{
			text = ENCOUNTER_JOURNAL,
			func = function() 
				securecall(ToggleEncounterJournal)
			end,
			notCheckable = true,
		},
		{
			text = " ",
			notCheckable = true,
		},		
		{
			text = GUILD,
			arg1 = IsInGuild('player'),
			func = function() 
				ToggleGuildFrame()
			end,
			notCheckable = true,
		},
		{
			text = SOCIAL_BUTTON,
			func = function() 
				securecall(ToggleFriendsFrame, 1) 
			end,
			notCheckable = true,
		},
		{
			text = GM_EMAIL_NAME,
			func = function() 
				securecall(ToggleHelpFrame) 
			end,
			notCheckable = true,
		},
		{
			text = " ",
			notCheckable = true,
		},	
		{
			text = DUNGEONS_BUTTON,
			func = function() 
				securecall(ToggleLFDParentFrame)
			end,
			notCheckable = true,
		},
		{
			text = PLAYER_V_PLAYER,
			func = function() 
				securecall(ToggleFrame, PVPFrame) 
			end,
			notCheckable = true,
		},
		{
			text = " ",
			notCheckable = true,
		},	
		{
			text = KEY_BINDINGS,
			func = function()
				if not KeyBindingFrame then 
					LoadAddOn('Blizzard_BindingUI') 
				end
				if not KeyBindingFrame:IsVisible() then
					ShowUIPanel(KeyBindingFrame)
					KeyBindingFrame.ignoreMenu = true
				else
					HideUIPanel(KeyBindingFrame)
				end
			end,
			notCheckable = true,
		},
		{
			text = MACROS,
			func = function()
				if not MacroFrame then 
					LoadAddOn('Blizzard_MacroUI') 
				end
				if not MacroFrame:IsVisible() then
					ShowUIPanel(MacroFrame)
				else
					HideUIPanel(MacroFrame)
				end
			end,
			notCheckable = true,
		},
	},
})
function MicroMenu.OnEnter(frame)
	local menuFrameMicro = CreateFrame('Frame', 'niomenuDropDownMenuMicro', UIParent, 'UIDropDownMenuTemplate')
	EasyMenu(MicroMenu.MenuEntries, menuFrameMicro, frame, 0, 0, 'MENU', 8)
end